package org.livee.data.command.bk;

/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import org.livee.data.db.DatabaseAdapter;
import org.livee.data.db.CommandFactory;
import org.livee.data.db.GetProfileAllCommand;
import org.livee.data.db.SetAdminProfileCommand;
import org.livee.data.db.GetAdminNeighborCommand;

import org.livee.data.expr.AbstractData;

import org.livee.util.Xml;


/**
 * DataManager is obsolete
 * @author Hideya Ochiai, The University of Tokyo
 * @see org.livee.data.command.Administrator
 */
public class DataManager {

	public static void main(String[] args) {

		
		GetProfileAllCommand getCommand=CommandFactory.createGetProfileAllCommand();
		GetAdminNeighborCommand neighbor=CommandFactory.createGetAdminNeighborCommand();
		
		while(true){
			DatabaseAdapter db=DatabaseAdapter.getInstance();
	
			String site=null;
			AbstractData profile=null;
			
			try{
				db.postCommand(getCommand);
				if(getCommand.succeeded()){
					profile=getCommand.getResult();
					
					System.out.println(Xml.toString(profile.getXml(Xml.newDocument())));
				}
				
				db.postCommand(neighbor);
				if(neighbor.succeeded()){
					AbstractData sites=neighbor.getAdminNeighbor();
					java.util.Iterator itr=sites.getChildren().iterator();
					while(itr.hasNext()){
						AbstractData adminSite=(AbstractData)itr.next();
						if(adminSite.getAttribute("type").equals("colleague")){
							site=adminSite.getAttribute("name");
							break;
						}
					}
				}
				
				if(profile!=null){
					SetAdminProfileCommand command=CommandFactory.createSetAdminProfileCommand(site, profile);
					db.postCommand(command);
					
					if(command.succeeded()){
						System.out.println("Admin Updated...");
					}
				}
			}
			catch(Exception e){
				
			}
			
			
			try{
				Thread.sleep(300000);
			}
			catch(Exception e){
				
			}
			
		}	
		
	}

}
