package org.livee.data.expr;
/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * 
 * @author Hideya Ochiai, The University of Tokyo
 */
public class AdminReplicateData implements AbstractData {

	AbstractData m_AdminConfig;
	// AbstractData m_AdminNeighbor;  Moved to AdminConfig 
	AbstractData m_ProfileSchema;
	AbstractData m_LocaleSchema;
	AbstractData m_SensorCollection;
	
	protected AdminReplicateData(){
		m_AdminConfig=null;
		// m_AdminNeighbor=null; Moved to AdminConfig
		m_ProfileSchema=null;
		m_LocaleSchema=null;
		m_SensorCollection=null;
	}

	public void append(AbstractData child) {
		if(child==null){
			return ;
		}
		if(child.getDataType().equals("AdminConfig")){
			m_AdminConfig=child;
		}
		
		// Moved to AdminConfig
		//if(child.getDataType().equals("AdminNeighbor")){
		//	m_AdminNeighbor=child;
		//}
		if(child.getDataType().equals("ProfileSchema")){
			m_ProfileSchema=child;
		}
		if(child.getDataType().equals("LocaleCollection")){
			m_LocaleSchema=child;
		}
		if(child.getDataType().equals("SensorCollection")){
			m_SensorCollection=child;
		}
	}

	public String getAttribute(String name) {
		return null;
	}

	public java.util.Map getAttributes() {
		return null;
	}

	public java.util.Collection getChildren() {
		java.util.ArrayList array=new java.util.ArrayList();
		array.add(m_AdminConfig);
		// array.add(m_AdminNeighbor); moved to AdminConfig
		array.add(m_ProfileSchema);
		array.add(m_LocaleSchema);
		array.add(m_SensorCollection);
		return array;
	}

	public String getDataType() {
		return "AdminReplicate";
	}

	public String getTextContent() {
		return null;
	}

	public Element getXml(Document doc) {
		
		String ns="http://live-e.org/Administrator/2007/03/";
		Element adminReplicate=doc.createElementNS(ns, "adminReplicate");
		
		if(m_AdminConfig!=null){
			adminReplicate.appendChild(m_AdminConfig.getXml(doc));
		}
		// Moved to AdminConfig
		// if(m_AdminNeighbor!=null){
		// 	adminReplicate.appendChild(m_AdminNeighbor.getXml(doc));
		//}
		if(m_ProfileSchema!=null){
			adminReplicate.appendChild(m_ProfileSchema.getXml(doc));
		}
		if(m_LocaleSchema!=null){
			adminReplicate.appendChild(m_LocaleSchema.getXml(doc));
		}
		if(m_SensorCollection!=null){
			adminReplicate.appendChild(m_SensorCollection.getXml(doc));
		}
		return adminReplicate;
	}

	public void remove(AbstractData child) {}

	public void removeAttribute(String name) {}

	public void setAttribute(String name, String value) {}

	public void setTextContent(String text) {}
}
