package org.livee.data.expr;

/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */


import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * 
 * @author Hideya Ochiai, The University of Tokyo
 */
public class AdminSchemaData implements AbstractData {

	AbstractData m_ProfileSchema;
	AbstractData m_LocaleSchema;
	
	protected AdminSchemaData(){
		m_ProfileSchema=null;
		m_LocaleSchema=null;
	}

	public void append(AbstractData child) {
		if(child==null){
			return ;
		}
		if(child.getDataType().equals("ProfileSchema")){
			m_ProfileSchema=child;
		}
		if(child.getDataType().equals("LocaleCollection")){
			m_LocaleSchema=child;
		}
	}

	public String getAttribute(String name) {
		return null;
	}

	public java.util.Map getAttributes() {
		return null;
	}

	public java.util.Collection getChildren() {
		java.util.ArrayList array=new java.util.ArrayList();
		array.add(m_ProfileSchema);
		array.add(m_LocaleSchema);
		return array;
	}

	public String getDataType() {
		return "AdminSchema";
	}

	public String getTextContent() {
		return null;
	}

	public Element getXml(Document doc) {
		
		String ns="http://live-e.org/Administrator/2007/03/";
		Element adminSchema=doc.createElementNS(ns, "adminSchema");
		
		if(m_ProfileSchema!=null){
			adminSchema.appendChild(m_ProfileSchema.getXml(doc));
		}
		if(m_LocaleSchema!=null){
			adminSchema.appendChild(m_LocaleSchema.getXml(doc));
		}
		return adminSchema;
	}

	public void remove(AbstractData child) {}

	public void removeAttribute(String name) {}

	public void setAttribute(String name, String value) {}

	public void setTextContent(String text) {}
}
