package org.livee.data.expr;
/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import java.util.Collection;
import java.util.Map;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * 
 * @author Hideya Ochiai, The University of Tokyo
 */
public class AdminServerData implements AbstractData {

	String m_Service;
	String m_URL;
	String m_LinkStatus;
	
	public void append(AbstractData child) {}

	public String getAttribute(String name) {
		if(name==null){
			return null;
		}
		if(name.equals("service")){
			return m_Service;
		}else if(name.equals("url")){
			return m_URL;
		}else if(name.equals("linkStatus")){
			return m_LinkStatus;
		}
		
		return null;
	}

	public Map getAttributes() {
		Map attrs=new java.util.Hashtable();

		if(m_Service!=null){
			attrs.put("service",m_Service);
		}
		if(m_URL!=null){
			attrs.put("url", m_URL);
		}
		if(m_LinkStatus!=null){
			attrs.put("linkStatus", m_LinkStatus);
		}
		return attrs;
	}

	public Collection getChildren() {
		return null;
	}

	public String getDataType() {
		return "AdminServer";
	}

	public String getTextContent() {
		return null;
	}

	public Element getXml(Document doc) {
		
		String ns="http://live-e.org/Administrator/2007/03/";
		Element server=doc.createElementNS(ns, "server");
				
		if(m_Service!=null){
			server.setAttribute("service",m_Service);
		}
		if(m_URL!=null){
			server.setAttribute("url", m_URL);
		}
		if(m_LinkStatus!=null){
			server.setAttribute("linkStatus", m_LinkStatus);
		}
		
		return server;
		
	}

	public void remove(AbstractData child) {}

	public void removeAttribute(String name) {

		if(name==null){
			return ;
		}
		
		if(name.equals("service")){
			m_Service=null;
		}else if(name.equals("url")){
			m_URL=null;
		}else if(name.equals("linkStatus")){
			m_LinkStatus=null;
		}
	}

	public void setAttribute(String name, String value) {
		
		if(name==null){
			return ;
		}
		
		if(name.equals("service")){
			m_Service=value;
		}else if(name.equals("url")){
			m_URL=value;
		}else if(name.equals("linkStatus")){
			m_LinkStatus=value;
		}
	}

	public void setTextContent(String text) {
	}


}
