package org.livee.data.expr;
/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import java.util.Collection;
import java.util.Map;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * 
 * @author Hideya Ochiai, The University of Tokyo
 */
public class SchemaData implements AbstractData {

	String m_Name;
	String m_Type;
	String m_Value;
	String m_Multilanguage;
	String m_Description;
	String m_Visibility;
	String m_Delegate;
	String m_Class;
	
	public void append(AbstractData child) {}

	public String getAttribute(String name) {
		if(name==null){
			return null;
		}
		if(name.equals("name")){
			return m_Name;
		}else if(name.equals("type")){
			return m_Type;
		}else if(name.equals("value")){
			return m_Value;
		}else if(name.equals("class")){
			return m_Class;
		}else if(name.equals("multilanguage")){
			return m_Multilanguage;
		}else if(name.equals("description")){
			return m_Description;
		}else if(name.equals("visibility")){
			return m_Visibility;
		}else if(name.equals("delegate")){
			return m_Delegate;
		}
		return null;
	}

	public Map getAttributes() {
		Map attrs=new java.util.Hashtable();

		if(m_Name!=null){
			attrs.put("name",m_Name);
		}
		if(m_Type!=null){
			attrs.put("type", m_Type);
		}
		if(m_Value!=null){
			attrs.put("value", m_Value);
		}
		if(m_Class!=null){
			attrs.put("class", m_Class);
		}
		if(m_Multilanguage!=null){
			attrs.put("multilanguage",m_Multilanguage);
		}
		if(m_Description!=null){
			attrs.put("description",m_Description);
		}
		if(m_Visibility!=null){
			attrs.put("visibility",m_Visibility);
		}
		if(m_Delegate!=null){
			attrs.put("delegate",m_Delegate);
		}
		
		
		return attrs;
	}

	public Collection getChildren() {
		return null;
	}

	public String getDataType() {
		return "Schema";
	}

	public String getTextContent() {
		return null;
	}

	public Element getXml(Document doc) {
		
		String ns="http://live-e.org/Schema/2007/03/";
		Element schema=doc.createElementNS(ns, "schema");
				
		if(m_Name!=null){
			schema.setAttribute("name",m_Name);
		}
		if(m_Type!=null){
			schema.setAttribute("type", m_Type);
		}
		if(m_Value!=null){
			schema.setAttribute("value", m_Value);
		}
		if(m_Class!=null){
			schema.setAttribute("class", m_Class);
		}
		if(m_Multilanguage!=null){
			schema.setAttribute("multilanguage", m_Multilanguage);
		}
		if(m_Description!=null){
			schema.setAttribute("description",m_Description);
		}
		if(m_Visibility!=null){
			schema.setAttribute("visibility",m_Visibility);
		}
		if(m_Delegate!=null){
			schema.setAttribute("delegate",m_Delegate);
		}
		
		
		return schema;
		
	}

	public void remove(AbstractData child) {}

	public void removeAttribute(String name) {

		if(name==null){
			return ;
		}
		
		if(name.equals("name")){
			m_Name=null;
		}else if(name.equals("type")){
			m_Type=null;
		}else if(name.equals("value")){
			m_Value=null;
		}else if(name.equals("class")){
			m_Class=null;
		}else if(name.equals("multilanguage")){
			m_Multilanguage=null;
		}else if(name.equals("description")){
			m_Description=null;
		}else if(name.equals("visibility")){
			m_Visibility=null;
		}else if(name.equals("delegate")){
			m_Delegate=null;
		}
	
	}

	public void setAttribute(String name, String value) {

		if(name==null){
			return ;
		}
		
		if(name.equals("name")){
			m_Name=value;
		}else if(name.equals("type")){
			m_Type=value;
		}else if(name.equals("value")){
			m_Value=value;
		}else if(name.equals("class")){
			m_Class=value;
		}else if(name.equals("multilanguage")){
			m_Multilanguage=value;
		}else if(name.equals("description")){
			m_Description=value;
		}else if(name.equals("visibility")){
			m_Visibility=value;
		}else if(name.equals("delegate")){
			m_Delegate=value;
		}
	}

	public void setTextContent(String text) {
	}

}
