package org.livee.data.expr;
/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import org.livee.util.Xml;
import org.w3c.dom.*;

/**
 * 
 * @author Hideya Ochiai, The University of Tokyo
 */
public class TestExpr {

	public static void main(String[] args) throws Exception {
		testAggExpr();
	}
	
	private static void testAggExpr() throws Exception {
		Document doc=Xml.parseXmlFile("test/aggHour.xml");
		Element xml=doc.getDocumentElement();
		
		ParserFactory pf=ParserFactory.getInstance();
		AbstractParser parser=pf.get("combined");
		
		AbstractData data=parser.parse(xml);
		
		System.out.println(Xml.toString(data.getXml(doc)));		
	}
	
	private static void testAdminNeighborNess() throws Exception {
		
		AbstractData base=null;
		AbstractData target=null;
		
		ParserFactory pf=ParserFactory.getInstance();
		AbstractParser parser=pf.get("adminNeighbor");

		Document doc=Xml.parseXmlFile("test/neighbor.xml");
		Element xml=doc.getDocumentElement();	
		base=parser.parse(xml);
		
		doc=Xml.parseXmlFile("test/neighbor_far.xml");
		xml=doc.getDocumentElement();
		target=parser.parse(xml);
		
		int c=AdminNeighborData.getRelation(base,target);
		
		switch(c){
		case AdminNeighborData.NEIGHBOR_NONE:
			System.out.println("NONE");
			break;
		case AdminNeighborData.NEIGHBOR_PARENT:
			System.out.println("PARENT");
			break;
		case AdminNeighborData.NEIGHBOR_CHILD:
			System.out.println("CHILD");
			break;
		case AdminNeighborData.NEIGHBOR_COLLEAGUE:
			System.out.println("COLLEAGUE");
			break;
		}
		
		
		

	}
	
	private static void testAdminNeighbor() throws Exception {
		Document doc=Xml.parseXmlFile("test/neighbor.xml");
		Element xml=doc.getDocumentElement();
		
		ParserFactory pf=ParserFactory.getInstance();
		AbstractParser parser=pf.get("adminNeighbor");
		
		AbstractData data=parser.parse(xml);
		
		System.out.println(Xml.toString(data.getXml(doc)));
		
		
	}

}
