package org.livee.data.query;
/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import org.livee.data.db.*;
import org.livee.data.expr.AbstractData;
import org.livee.data.expr.AbstractParser;
import org.livee.util.Xml;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * 
 * @author Hideya Ochiai, The University of Tokyo
 */
public class TestQuery {

	public static void main(String[] args) throws Exception {
		testQueryResolver();
	}
	
	
	public static void testSearch() {
		Document doc=Xml.parseXmlFile("test/query.xml");
		Element root=doc.getDocumentElement();

		String query=Xml.toString(root);
		
		org.livee.data.srv.Admin200703 admin=new org.livee.data.srv.Admin200703();
		String response=admin.search(query);
		
		System.out.println(query);
		System.out.println(response);
	}
	
	public static void testQueryResolver() throws Exception {

		Document doc=Xml.parseXmlFile("test/query.xml");
		Element root=doc.getDocumentElement();
		
		ParserFactory pf=ParserFactory.getInstance();
		AbstractParser query_parser=pf.get("query");
		
		AbstractData query=query_parser.parse(root);

		org.livee.data.query.resolve.QueryResolver resolver=org.livee.data.query.resolve.QueryResolver.getInstance();
		
		//AbstractData queryResponse=resolver.resolve(query);
		
		//if(queryResponse!=null){
		//	System.out.println(Xml.toString(queryResponse.getXml(doc)));
		//}
	}
	public static void testQueryProcessCommand() throws Exception {
		
		Document doc=Xml.parseXmlFile("test/query.xml");
		Element root=doc.getDocumentElement();
		
		ParserFactory pf=ParserFactory.getInstance();
		AbstractParser query_parser=pf.get("query");
		
		AbstractData query=query_parser.parse(root);

		DatabaseAdapter db=DatabaseAdapter.getInstance();		
		QueryProcessCommand command=new QueryProcessCommand(query);
		
		db.postCommand(command);
		
		if(command.succeeded()){
			AbstractData response=command.getQueryResponse();
			
			System.out.println(Xml.toString(response.getXml(doc)));
		}
	}

}
