package org.livee.data.replicate;
/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import java.sql.Connection;
import java.util.Map;
import org.livee.util.W3CTimestamp;

import org.livee.data.db.IDbCommand;

/**
 * 
 * @author Hideya Ochiai, The University of Tokyo
 */
public class GetSlaveReplicationProfileCommand implements IDbCommand {

	String m_ReplicationType;
	java.util.Calendar m_Done;
	boolean m_bSucceeded;
	
	public GetSlaveReplicationProfileCommand(String replicationType){
		m_ReplicationType=replicationType;
		m_Done=null;
		m_bSucceeded=false;
	}
	
	public boolean succeeded(){
		return m_bSucceeded;
	}
	
	public java.util.Calendar getDone(){
		return m_Done;
	}
	
	public void execCommand(Connection connection, Map conf) throws Exception {
		
		java.sql.Statement stmt=null;
		try{
			stmt=connection.createStatement();
		
			String sql="SELECT replicationType, done FROM slaveReplicationProfile WHERE replicationType=\'"+m_ReplicationType+"\';";
			java.sql.ResultSet rset=stmt.executeQuery(sql);
			
			if(rset.next()){
				m_Done=W3CTimestamp.parse(W3CTimestamp.toString(rset.getTimestamp(2), java.util.TimeZone.getDefault()));
				m_bSucceeded=true;
			}	
		}
		catch(Exception e){
			e.printStackTrace();
		}
		finally{
			stmt.close();
		}

	}

	public String getCommandName() {
		return "GetSlaveReplicationProfile";
	}

	public short getImplVersion() {
		return 0x0100;
	}

}
