package org.livee.data.replicate;
/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import java.util.Collection;
import java.util.Map;

import org.livee.data.expr.AbstractData;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * 
 * @author Hideya Ochiai, The University of Tokyo
 */
public class SensorElementReplicationData implements AbstractData {

	String m_ID;
	String m_CombinedID;
	String m_Working;
	
	protected SensorElementReplicationData(){
		m_ID=null;
		m_CombinedID=null;
		m_Working=null;
	}
	
	public void append(AbstractData child) {}

	public String getAttribute(String name) {
		if(name==null){
			return null;
		}
		if(name.equals("id")){
			return m_ID;
		}else if(name.equals("combined_id")){
			return m_CombinedID;
		}else if(name.equals("working")){
			return m_Working;
		}
		return null;
	}

	public Map getAttributes() {
		Map attrs=new java.util.Hashtable();

		if(m_ID!=null){
			attrs.put("id",m_ID);
		}
		if(m_CombinedID!=null){
			attrs.put("combined_id",m_CombinedID);
		}
		if(m_Working!=null){
			attrs.put("working",m_Working);
		}
		return attrs;
	}

	public Collection getChildren() {
		return null;
	}

	public String getDataType() {
		return "SensorElementReplication";
	}

	public String getTextContent() {
		return null;
	}

	public void remove(AbstractData child) {}

	public void removeAttribute(String name) {
		if(name==null){
			return ;
		}
		if(name.equals("id")){
			m_ID=null;
		}else if(name.equals("combined_id")){
			m_CombinedID=null;
		}else if(name.equals("working")){
			m_Working=null;
		}
	}

	public void setAttribute(String name, String value) {
		
		if(name==null){
			return ;
		}
		if(name.equals("id")){
			m_ID=value;
		}else if(name.equals("combined_id")){
			m_CombinedID=value;
		}else if(name.equals("working")){
			m_Working=value;
		}
	}

	public void setTextContent(String text) {}

	public Element getXml(Document doc) {
		String ns="http://live-e.org/DataManager/2007/03/";
		Element val=doc.createElementNS(ns, "sensorElement");
		if(m_ID!=null){
			val.setAttribute("id",m_ID);
		}
		if(m_CombinedID!=null){
			val.setAttribute("combined_id", m_CombinedID);
		}
		if(m_Working!=null){
			val.setAttribute("working", m_Working);
		}
		
		return val;
	}


}
