package org.livee.test;
/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import org.livee.data.soap.client.*;

/**
 * 
 * @author Hideya Ochiai, The University of Tokyo
 */
public class TestGlobalDataProvider200703 {

	public static void main(String[] args) {
		
		try{
			DataProvider200703Service dps=new DataProvider200703ServiceLocator();
			DataProvider200703_PortType srv=dps.getDataProvider200703(new java.net.URL("http://127.0.0.1/axis/services/GlobalDataProvider200703"));
			
			System.out.println("GetProfileSchema");
			System.out.println(srv.getProfileSchema());
			System.out.println("GetLatestDataAll");
			System.out.println(srv.getLatestDataAll("JST","Japanese"));
			System.out.println("GetLatestData live-e.org/Virtual/01000001/");
			System.out.println(srv.getLatestData("live-e.org/Virtual/01000001/","JST","Japanese"));
			System.out.println("GetLatestDataByAreaRect");
			System.out.println(srv.getLatestDataByAreaRect(90,-90,180,-180,"JST","Japanese"));

			System.out.println("GetDataDailyAggregated live-e.org/Virtual/01000001/");
			System.out.println(srv.getDataDailyAggregated("live-e.org/Virtual/01000001/","2007-01-01T00:00:00.0000000+09:00","2007-08-01T00:00:00.0000000+09:00","JST","Japanese"));
			System.out.println("GetDataHourlyAggregated live-e.org/Virtual/01000001/");
			System.out.println(srv.getDataHourlyAggregated("live-e.org/Virtual/01000001/","2007-01-01T00:00:00.0000000+09:00","2007-08-01T00:00:00.0000000+09:00","JST","Japanese"));
			System.out.println("GetDataMonthlyAggregated live-e.org/Virtual/01000001/");
			System.out.println(srv.getDataMonthlyAggregated("live-e.org/Virtual/01000001/","2007-01-01T00:00:00.0000000+09:00","2007-08-01T00:00:00.0000000+09:00","JST","Japanese"));

			System.out.println("GetProfileAll");
			System.out.println(srv.getProfileAll("JST","Japanese"));
			System.out.println("GetProfile live-e.org/Virtual/01000001/");
			System.out.println(srv.getProfile("live-e.org/Virtual/01000001/","JST","Japanese"));
			System.out.println("GetProfileByAreaRect");
			System.out.println(srv.getProfileByAreaRect(90,-90,180,-180,"JST","Japanese"));

			//System.out.println("GetArchiveCombinedData live-e.org/Virtual/01000001/");
			//System.out.println(srv.getArchiveCombinedData("live-e.org/Virtual/01000001/","2007-01-01T00:00:00.0000000+09:00","2007-08-01T00:00:00.0000000+09:00","JST","Japanese"));
			System.out.println("GetArchiveProfile live-e.org/Virtual/01000001/");
			System.out.println(srv.getArchiveProfile("live-e.org/Virtual/01000001/","2007-01-01T00:00:00.0000000+09:00","2007-08-01T00:00:00.0000000+09:00","JST","Japanese"));
		}
		catch(Exception e){
			e.printStackTrace();
		}

	}

}
